VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsGSRegSetting"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

    Private Const REG_NONE As Long = 0
    Private Const REG_SZ  As Long = 1
    Private Const REG_EXPAND_SZ  As Long = 2
    Private Const REG_BINARY  As Long = 3
    Private Const REG_DWORD   As Long = 4
    Private Const REG_DWORD_LITTLE_ENDIAN  As Long = 4
    Private Const REG_DWORD_BIG_ENDIAN  As Long = 5
    Private Const REG_LINK As Long = 6
    Private Const REG_MULTI_SZ  As Long = 7
    Private Const REG_RESOURCE_LIST As Long = 8
    Private Const REG_FULL_RESOURCE_DESCRIPTOR As Long = 9
    Private Const REG_RESOURCE_REQUIREMENTS_LIST As Long = 10

    Private Declare Function ExpandEnvironmentStrings _
                                             Lib "kernel32" Alias "ExpandEnvironmentStringsA" _
                                             (ByVal lpSrc As String, _
                                              ByVal lpDst As String, _
                                              ByVal nSize As Long) As Long

    ' lokale Variablen/Konstanten fr Eigenschaften
    Private mvarSettingName As String
    Private mvarSetting As Variant
    Private mvarRegDataType As Long
    Private mvarVarTypeVB As VbVarType
    Private mvarTypeNameVB As String
    Private Const mClassName As String = "clsGSRegSetting"
    
Private Function IsUnexpEnviron(ByVal StringToCheck As String) As Boolean
    ' prft, ob der in StringToCheck bergebene String eine _
      auflsbare (z.B. "%SystemRoot%\system32\rundll32.exe") _
      Environmentvariable enthlt.
    
    ' Rckgabewert:     True, _
                                    wenn der String eine auflsbare EnvVar. enthlt
    ' Rckgabewert:     False, _
                                    wenn der String keine auflsbare EnvVar. enthlt
    
    Dim bRet As Boolean
    Dim lngRet As Long
    Dim NumChar As Long
    Dim strBuffer As String
    
    ' erforderlich Lnge fr strBuffer feststellen
    lngRet = ExpandEnvironmentStrings(StringToCheck, vbNullString, NumChar)
    ' NumChar enthlt jetzt die fr strBuffer erforderliche _
      Lnge (inkl. abschliessendes vbNullChar) _
      oder 0, wenn ein Fehler aufgetreten ist
    If lngRet Then
        NumChar = lngRet
        strBuffer = String$(NumChar, 0)
        lngRet = ExpandEnvironmentStrings(StringToCheck, strBuffer, NumChar)
        If lngRet Then
            ' wenn StringToCheck und Left$(strBuffer, NumChar - 1) _
              nicht mehr gleich sind, dann wurde ein auflsbarer String _
              erkannt
            NumChar = InStr(strBuffer, vbNullChar)
            If NumChar Then
                strBuffer = Left$(strBuffer, NumChar - 1)
            End If
            bRet = strBuffer <> StringToCheck
        End If
    End If
    IsUnexpEnviron = bRet
End Function
    
    
' Setting
Public Property Let Setting(ByVal vData As Variant)
    mvarSetting = vData
End Property

Public Property Set Setting(ByVal vData As Variant)
    Set mvarSetting = vData
End Property

Public Property Get Setting() As Variant
    If IsObject(mvarSetting) Then
        Set Setting = mvarSetting
    Else
        Setting = mvarSetting
    End If
End Property


''''''' RegDataType (z.B. REG_SZ, REG_DWORD usw.)
''''''Public Property Let RegDataType(ByVal vData As Long)
''''''    mvarRegDataType = vData
''''''''''''''    ' mvarSetting muss bereits mit Daten versorgt sein, _
''''''''''''''      damit mvarVarTypeVB und mvarTypeNameVB hier _
''''''''''''''      auf richtige Werte eingestellt werden knnen.
''''''''''''''    If Not IsEmpty(mvarSetting) Then
''''''''''''''        mvarVarTypeVB = VarType(mvarSetting)
''''''''''''''        mvarTypeNameVB = TypeName(mvarSetting)
''''''''''''''    End If
''''''End Property

Public Property Get RegDataType() As Long
    If VarType(mvarSetting) And vbArray Then
        ' mvarSetting enthlt ein Array
        Select Case True
            Case VarType(mvarSetting) And vbByte
                ' ByteArray wird als Typ REG_BINARY behandelt
                RegDataType = REG_BINARY
            Case VarType(mvarSetting) And vbString
                ' StringArray wird als Type REG_MULTI_SZ behandelt
                RegDataType = REG_MULTI_SZ
            Case Else
                ' Andere Arrays sind keine zulssigen Reg-Typen
                RegDataType = REG_NONE
        End Select
    Else
        Select Case VarType(mvarSetting)
            Case vbByte, vbInteger, vbLong
                RegDataType = REG_DWORD
            Case vbString
                If IsUnexpEnviron(mvarSetting) Then
                    RegDataType = REG_EXPAND_SZ
                Else
                    RegDataType = REG_SZ
                End If
            Case Else
                RegDataType = REG_NONE
        End Select
    End If
End Property

' VarTypeVB (ReadOnly),
'  DatenTyp wie er von VBA.VarType zurckgegeben wird
Public Property Get VarTypeVB() As VbVarType
    VarTypeVB = VarType(mvarSetting)
End Property


' TypeNameVB (ReadOnly),
'  DatenTypName wie er von VBA.TypeName zurckgegeben wird
Public Property Get TypeNameVB() As String
    TypeNameVB = TypeName(mvarSetting)
End Property


' KeyName
Public Property Let SettingName(ByVal vData As String)
    mvarSettingName = vData
End Property

Public Property Get SettingName() As String
    SettingName = mvarSettingName
End Property



