VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsGSRegistry"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
    
    Private Const ERROR_NO_MORE_ITEMS  As Long = 259
    
    Private Const REG_NONE As Long = 0
    Private Const REG_SZ  As Long = 1
    Private Const REG_EXPAND_SZ  As Long = 2
    Private Const REG_BINARY  As Long = 3
    Private Const REG_DWORD   As Long = 4
    Private Const REG_DWORD_LITTLE_ENDIAN  As Long = 4
    Private Const REG_DWORD_BIG_ENDIAN  As Long = 5
    Private Const REG_LINK As Long = 6
    Private Const REG_MULTI_SZ  As Long = 7
    Private Const REG_RESOURCE_LIST As Long = 8
    Private Const REG_FULL_RESOURCE_DESCRIPTOR As Long = 9
    Private Const REG_RESOURCE_REQUIREMENTS_LIST As Long = 10
    
    Private Const REG_OPTION_NON_VOLATILE As Long = 0
    
    Private Const KEY_QUERY_VALUE As Long = 1
    Private Const KEY_SET_VALUE As Long = 2
    Private Const KEY_CREATE_SUB_KEY As Long = 4
    Private Const KEY_ENUMERATE_SUB_KEYS  As Long = 8
        
'    Private Const KEY_NOTIFY = &H10
'    Private Const SYNCHRONIZE = &H100000
'    Private Const KEY_CREATE_LINK = &H20
'    Private Const KEY_EXECUTE = ((KEY_READ) And (Not SYNCHRONIZE))
'    Private Const KEY_READ = ((STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not SYNCHRONIZE))
'    Private Const KEY_WRITE = ((STANDARD_RIGHTS_WRITE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY) And (Not SYNCHRONIZE))
'    Private Const KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL Or KEY_QUERY_VALUE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_CREATE_LINK) And (Not SYNCHRONIZE))
    

' ffentliche Aufzhlungen
    
    Public Enum HKeyEnum
        ClassesRoot = &H80000000
        CurrentUser = &H80000001
        LocalMachine = &H80000002
        Users = &H80000003
        PerformanceData = &H80000004
        CurrentConfig = &H80000005
        DynData = &H80000006
    End Enum
    
    Public Enum RegDataTypes
        UnknownDataType = REG_NONE
        Text = REG_SZ
        TextUnexpEnviron = REG_EXPAND_SZ
        BinaryData = REG_BINARY
        Numeric_Long = REG_DWORD
        MultipleText = REG_MULTI_SZ
        'Numeric_Long_LittleEndian = REG_DWORD
        'Numeric_Long_BigEndian = REG_DWORD_BIG_ENDIAN
        'Link = REG_LINK    ' Anwendungen sollen diesen Typ nicht benutzen
        'ResourceList = REG_RESOURCE_LIST
        'FullResourceDescriptor = REG_FULL_RESOURCE_DESCRIPTOR
        'ResourceRequirementsList = REG_RESOURCE_REQUIREMENTS_LIST
    End Enum
        
    Private Type FILETIME
            dwLowDateTime As Long
            dwHighDateTime As Long
    End Type
    
    
    ' Deklarationen fr API-Aufrufe
    
    Private Declare Function FormatMessage _
                                             Lib "kernel32" Alias "FormatMessageA" _
                                             (ByVal dwFlags As Long, _
                                              lpSource As Any, _
                                              ByVal dwMessageId As Long, _
                                              ByVal dwLanguageId As Long, _
                                              ByVal lpBuffer As String, _
                                              ByVal nSize As Long, _
                                              Arguments As Long) As Long
    
    Private Declare Function RegEnumKeyEx _
                                             Lib "advapi32.dll" Alias "RegEnumKeyExA" _
                                             (ByVal hKey As Long, _
                                              ByVal dwIndex As Long, _
                                              ByVal lpName As String, _
                                              lpcbName As Long, _
                                              ByVal lpReserved As Long, _
                                              ByVal lpClass As String, _
                                              lpcbClass As Long, _
                                              lpftLastWriteTime As FILETIME) As Long
    
    Private Declare Function RegEnumValue _
                                             Lib "advapi32.dll" Alias "RegEnumValueA" _
                                             (ByVal hKey As Long, _
                                              ByVal dwIndex As Long, _
                                              ByVal lpValueName As String, _
                                              lpcbValueName As Long, _
                                              ByVal lpReserved As Long, _
                                              lpType As Long, _
                                              lpData As Byte, _
                                              lpcbData As Long) As Long
    
    Private Declare Function RegOpenKeyEx _
                                             Lib "advapi32.dll" Alias "RegOpenKeyExA" _
                                             (ByVal hKey As Long, _
                                              ByVal lpSubKey As String, _
                                              ByVal ulOptions As Long, _
                                              ByVal samDesired As Long, _
                                              phkResult As Long) As Long
    
    Private Declare Function RegCloseKey _
                                             Lib "advapi32.dll" _
                                             (ByVal hKey As Long) As Long
    
    Private Declare Function RegCreateKeyEx _
                                             Lib "advapi32.dll" Alias "RegCreateKeyExA" _
                                             (ByVal hKey As Long, _
                                              ByVal lpSubKey As String, _
                                              ByVal Reserved As Long, _
                                              ByVal lpClass As String, _
                                              ByVal dwOptions As Long, _
                                              ByVal samDesired As Long, _
                                              ByVal lpSecurityAttributes As Long, _
                                              phkResult As Long, _
                                              lpdwDisposition As Long) As Long
    
    ' RegQueryValueEX _
      Um Typsicherheit zu erlangen, wird die Funktion RegQueryValueEX _
      in vier verschiedenen Varianten deklariert (String, Long, Byte, NULL)
    Private Declare Function RegQueryValueExString _
                                             Lib "advapi32.dll" Alias "RegQueryValueExA" _
                                             (ByVal hKey As Long, _
                                              ByVal lpValueName As String, _
                                              ByVal lpReserved As Long, _
                                              lpType As Long, _
                                              ByVal lpData As String, _
                                              lpcbData As Long) As Long
    
    Private Declare Function RegQueryValueExLong _
                                             Lib "advapi32.dll" Alias "RegQueryValueExA" _
                                             (ByVal hKey As Long, _
                                              ByVal lpValueName As String, _
                                              ByVal lpReserved As Long, _
                                              lpType As Long, _
                                              lpData As Long, _
                                              lpcbData As Long) As Long
     
    Private Declare Function RegQueryValueExByte _
                                             Lib "advapi32.dll" Alias "RegQueryValueExA" _
                                             (ByVal hKey As Long, _
                                              ByVal lpValueName As String, _
                                              ByVal lpReserved As Long, _
                                              lpType As Long, _
                                              lpData As Byte, _
                                              lpcbData As Long) As Long
   
    Private Declare Function RegQueryValueExNULL _
                                             Lib "advapi32.dll" Alias "RegQueryValueExA" _
                                             (ByVal hKey As Long, _
                                              ByVal lpValueName As String, _
                                              ByVal lpReserved As Long, _
                                              lpType As Long, _
                                              ByVal lpData As Long, _
                                              lpcbData As Long) As Long
    
    ' RegSetValueEx _
      Um Typsicherheit zu erlangen, wird die Funktion RegSetValueEx in _
      drei verschiedenen Varianten deklariert (String, Long, Byte)
    Private Declare Function RegSetValueExString _
                                             Lib "advapi32.dll" Alias "RegSetValueExA" _
                                             (ByVal hKey As Long, _
                                              ByVal lpValueName As String, _
                                              ByVal lpReserved As Long, _
                                              ByVal dwType As Long, _
                                              ByVal lpValue As String, _
                                              ByVal cbData As Long) As Long
    
    Private Declare Function RegSetValueExLong _
                                             Lib "advapi32.dll" Alias "RegSetValueExA" _
                                             (ByVal hKey As Long, _
                                              ByVal lpValueName As String, _
                                              ByVal lpReserved As Long, _
                                              ByVal dwType As Long, _
                                              lpValue As Long, _
                                              ByVal cbData As Long) As Long
    
    Private Declare Function RegSetValueExByte _
                                             Lib "advapi32.dll" Alias "RegSetValueExA" _
                                             (ByVal hKey As Long, _
                                              ByVal lpValueName As String, _
                                              ByVal lpReserved As Long, _
                                              ByVal dwType As Long, _
                                              lpValue As Byte, _
                                              ByVal cbData As Long) As Long
                                              
    
    Private Declare Function RegQueryInfoKey _
                                             Lib "advapi32.dll" Alias "RegQueryInfoKeyA" _
                                             (ByVal hKey As Long, _
                                              ByVal lpClass As String, _
                                              lpcbClass As Long, _
                                              ByVal lpReserved As Long, _
                                              lpcSubKeys As Long, _
                                              lpcbMaxSubKeyLen As Long, _
                                              lpcbMaxClassLen As Long, _
                                              lpcValues As Long, _
                                              lpcbMaxValueNameLen As Long, _
                                              lpcbMaxValueLen As Long, _
                                              lpcbSecurityDescriptor As Long, _
                                              lpftLastWriteTime As FILETIME) As Long
    
    Private Declare Function RegDeleteKey _
                                             Lib "advapi32.dll" Alias "RegDeleteKeyA" _
                                             (ByVal hKey As Long, _
                                              ByVal lpSubKey As String) As Long
    
    Private Declare Function RegDeleteValue _
                                             Lib "advapi32.dll" Alias "RegDeleteValueA" _
                                             (ByVal hKey As Long, _
                                              ByVal lpValueName As String) As Long
                                              
    Private Declare Function ExpandEnvironmentStrings _
                                             Lib "kernel32" Alias "ExpandEnvironmentStringsA" _
                                             (ByVal lpSrc As String, _
                                              ByVal lpDst As String, _
                                              ByVal nSize As Long) As Long

    Private Declare Function GetLastError Lib "kernel32" () As Long

    Private Declare Sub MoveMemory _
                                      Lib "kernel32" Alias "RtlMoveMemory" _
                                      (Destination As Any, _
                                       Source As Any, _
                                       ByVal Length As Long)
                                              

' Ende der API - Deklarationen
'___________________
    
    
' \\\ lokale Variablen/Konstanten fr Eigenschaften
    Private Const mClassName = "clsGSRegistry"
    Private mvarRegError As clsGSError
    
' \\\ Eigenschaften:

' ClassName (ReadOnly)
Public Property Get ClassName() As String
    ClassName = mClassName
End Property

' RegError (ReadOnly)
Public Property Get RegError() As clsGSError
    Set RegError = mvarRegError
End Property


' \\\ Private Methoden

' GetErrorDescription
Private Function GetErrorDescription(ByVal ErrNumber As Long) As String
    ' GetErrorDescription ermittelt den zu der in ErrNumber bergebenen _
      Fehlernummer gehrenden Fehlertext mit Hilfe der _
      API-Funktion FormatMessage
      
    Const FORMAT_MESSAGE_FROM_SYSTEM     As Long = &H1000
    Const FORMAT_MESSAGE_MAX_WIDTH_MASK  As Long = &HFF
    Const MsgLen As Long = 512
    Const lngNull As Long = 0
    Dim ErrText As String
    Dim Ret As Long
    
    ErrText = String(MsgLen, 0)
    Ret = FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM Or _
                                          FORMAT_MESSAGE_MAX_WIDTH_MASK, _
                                          ByVal lngNull, _
                                          ErrNumber, _
                                          lngNull, _
                                          ErrText, _
                                          MsgLen, _
                                          ByVal lngNull)
                                
    If Ret Then
        ' nachfolgende vbNullChar in Fehlertext abschneiden
        GetErrorDescription = Left$(ErrText, Ret)
    Else
        GetErrorDescription = vbNullString
    End If
End Function

' IsUnexpEnviron
Private Function IsUnexpEnviron(ByVal StringToCheck As String) As Boolean
    ' prft, ob der in StringToCheck bergebene String eine _
      auflsbare (z.B. "%SystemRoot%\system32\rundll32.exe") _
      Environmentvariable enthlt.
    
    ' Rckgabewert:     True, _
                                    wenn der String eine auflsbare EnvVar. enthlt
    ' Rckgabewert:     False, _
                                    wenn der String keine auflsbare EnvVar. enthlt
    
    Dim bRet As Boolean
    Dim lngRet As Long
    Dim NumChar As Long
    Dim strBuffer As String
    
    ' erforderlich Lnge fr strBuffer feststellen
    lngRet = ExpandEnvironmentStrings(StringToCheck, vbNullString, NumChar)
    ' NumChar enthlt jetzt die fr strBuffer erforderliche _
      Lnge (inkl. abschliessendes vbNullChar) _
      oder 0, wenn ein Fehler aufgetreten ist
    If lngRet Then
        NumChar = lngRet
        strBuffer = String$(NumChar, 0)
        ' Env.-Referenz(en) auflsen
        lngRet = ExpandEnvironmentStrings(StringToCheck, strBuffer, NumChar)
        ' lngRet enthlt hier die Anzahl der nach strBuffer kopierten Bytes _
          oder 0 bei Fehler
        If lngRet Then
            ' abschliessende vbNullChar abschneiden
            NumChar = InStr(strBuffer, vbNullChar)
            If NumChar Then
                strBuffer = Left$(strBuffer, NumChar - 1)
            End If
            
            ' wenn StringToCheck und Left$(strBuffer, NumChar - 1) _
              nicht mehr gleich sind, dann wurde ein auflsbarer String _
              erkannt
            bRet = strBuffer <> StringToCheck
        End If
    End If
    IsUnexpEnviron = bRet
End Function



' \\\ ffentliche Methoden

Public Function ExpandEnvString(EnvString As String) As String
    ' lst Referenzen auf Environment-Variablen wie z.B. _
      "%PATH%" oder _
      "%SystemRoot%\system32\rundll32.exe" _
      auf.
    
    ' Rckgabewert: die aufgelste in EnvString bergebene Referenz.
    ' Im Fehlerfall wird ein String der Lnge 0 zurckgegeben, _
      Informationen zum Fehler in mvarRegError.
      
    ' Wenn die Methoden GetSetting und GetAllSetting RegKeyObjecte mit _
      dem DatenTyp REG_EXPAND_SZ zurckgeben, kann der in _
      Setting enthaltene Wert (Referenz auf Environmentvariable) mit dieser Funktion _
      aufgelst werden
      
    ' Aufruf:
    '
    '   Dim RC as clsGSRegistry
    '   Set RC = New clsGSRegistry
    '   Debug.Print RC.ExpandEnvString ("%SystemRoot%\system32\rundll32.exe")
    '   ' das Ergebnis im Debug-Fenster wre in diesem Fall z.B.:
    '   ' "C:\WINNT\system32\rundll32.exe"
      
    Dim Ret As Long
    Dim NumChar As Long
    Dim strBuffer As String
    
    Ret = ExpandEnvironmentStrings(EnvString, vbNullString, NumChar)
    ' Ret enthlt die erforderlich Anzahl Bytes fr strBuffer _
      oder 0 bei Fehler
    If Ret Then
        NumChar = Ret
        strBuffer = String$(NumChar, 0)
        ' Env. - Referenzen auflsen
        Ret = ExpandEnvironmentStrings(EnvString, strBuffer, NumChar)
        ' Ret enthlt hier die Lnge der zurckgegebenen Bytes _
          oder 0 bei Fehler
        If Ret Then
            NumChar = InStr(strBuffer, vbNullChar)
            If NumChar Then
                strBuffer = Left$(strBuffer, NumChar - 1)
            End If
        End If
    End If
    
    If Ret Then
        ExpandEnvString = strBuffer
    Else
        ExpandEnvString = vbNullString
        Ret = GetLastError
        If Ret Then
            ' Fehlerobjekt versorgen
            mvarRegError.Number = Ret
            mvarRegError.Description = GetErrorDescription(Ret)
            mvarRegError.Source = mClassName & ".ExpandEnvString"
        End If
    End If
End Function


Public Function HasSubSections(hKey As HKeyEnum, Section As String) As Long
    ' Prft, ob eine Section (RegistryKey) untergeordnete Sections (Keys) enthlt.
    ' Rckgabewert: Anzahl der untergeordneten Sections (0 ... x)
    ' Rckgabewert: -1 im Fehlerfall _
                               Informationen zum Fehler in mvarClassError
                        
    Const N As Long = 0
    Dim Ret As Long
    Dim hOpened As Long
    Dim NumSections As Long
    Dim FT As FILETIME
    
    ' RegError zurcksetzen
    mvarRegError.Clear
    
    Ret = RegOpenKeyEx(hKey, Section, N, KEY_QUERY_VALUE, hOpened)
    ' Ret ist 0, wenn RegOpenKeyEx erfolgreich war
    
    If Ret = 0 Then
        ' Anzahl der Unterverzeichnisse ermitteln
        Ret = RegQueryInfoKey(hOpened, vbNullString, N, N, NumSections, N, N, N, N, N, N, FT)
        ' hOpened wieder schliessen
        RegCloseKey hOpened
    End If
    
    ' Ret ist hier 0, wenn alles fehlerfrei gelaufen ist
    
    If Ret = 0 Then
        HasSubSections = NumSections
    Else
        ' Es ist ein Fehler aufgetreten
        HasSubSections = -1
        mvarRegError.Number = Ret
        mvarRegError.Description = GetErrorDescription(Ret)
        mvarRegError.Source = mClassName & ".HasSubSections"
    End If
End Function


Public Function HasSettings(hKey As HKeyEnum, Section As String) As Long
    ' Prft, wieviel Eintrge (Settings) unter dem in hkey/Section _
      angegebenen Pfad gespeichert sind.
    
    ' Rckgabewert: Anzahl der Eintrge (0 ... x) _
                               (der Eintrag "Standard" wird nur mitgezhlt, _
                                wenn er tatschlich einen Wert enthlt, _
                                bei "Wert nicht gesetzt" wird dieser Eintrag nicht mitgezhlt)
    ' Rckgabewert: -1 im Fehlerfall _
                               Informationen zum Fehler in mvarClassError
                               
    Const N As Long = 0
    Dim Ret As Long
    Dim hOpened As Long
    Dim NumSettings As Long
    Dim FT As FILETIME
    
    ' RegError rcksetzen
    mvarRegError.Clear
    
    Ret = RegOpenKeyEx(hKey, Section, N, KEY_QUERY_VALUE, hOpened)
    ' Ret ist 0, wenn RegOpenKeyEx erfolgreich war
    
    If Ret = 0 Then
        Ret = RegQueryInfoKey(hOpened, vbNullString, N, N, N, N, N, NumSettings, N, N, N, FT)
        RegCloseKey hOpened
    End If
    
    If Ret = 0 Then
        ' RegOpenKeyEx und RegQueryInfoKey _
          sind fehlerfrei gelaufen
        HasSettings = NumSettings
    Else
        ' Es ist ein Fehler aufgetreten
        HasSettings = -1
        mvarRegError.Number = Ret
        mvarRegError.Description = GetErrorDescription(Ret)
        mvarRegError.Source = mClassName & ".HasSettings"
    End If
End Function


Public Function GetSubSectionNames(hKey As HKeyEnum, Section As String) As Collection
    ' Auflisten aller untergeordneten Pfade (SubSections), _
      die dem mit hkey/Section bergebenen Pfad untergeordnet sind.
      
    ' Rckgabewert: Collection mit den Namen aller SubSections, _
                                enthlt die Section keine untergeordneten SubSections, _
                                dann wird eine leere Collection zurckgegeben. _
                                Im Fehlerfall wird "Nothing" zurckgegeben, _
                                Informationen zum Fehler stehen in mvarRegError
    
    ' Aufruf: _
      Dim MyRClass as clsGSRegistry _
      Dim MyCollection as Collection _
      Set MyRClass = new clsGSRegistry _
      MyCollection = GetSubSectionNames(LocalMachine, "Software") _
      If not (MyCollection is Nothing) then _
          ' Auflistung OK _
      Else _
          ' Fehler (Fehlerinformationen in MyRClass.RegError) _
      End If
    Const N As Long = 0
    Dim SColl As Collection
    Dim Ret As Long
    Dim hOpened As Long
    Dim Index As Long
    Dim strBuffer As String
    Dim BufLen As Long
    Dim MaxBufLen As Long
    Dim FT As FILETIME
    
    
    ' RegError zurcksetzen
    mvarRegError.Clear
    
    ' neue leere Collection erzeugen
    Set SColl = New Collection
    
    ' hkey/Section ffnen
    Ret = RegOpenKeyEx(hKey, Section, 0&, KEY_ENUMERATE_SUB_KEYS Or KEY_QUERY_VALUE, hOpened)
    ' Ret ist hier 0, wenn RegOpenKeyEx fehlerfrei gelaufen ist.
    
    If Ret = 0 Then
        ' Lnge des lngsten SubSection-Namens holen
        Ret = RegQueryInfoKey(hOpened, N, N, N, N, MaxBufLen, N, N, N, N, N, FT)
        ' ret ist hier 0, wenn RegQueryInfoKey fehlerfrei gelaufen ist
        
        
        ' SubSections auflisten (beginnend mit Index 0)
        ' Do While Ret = 0 bewirkt, _
          1.) dass die Schleife nur ausgefhrt wird, _
               wenn das vorangegangene RegQueryInfoKey fehlerfrei war. _
          2.) dass die Schleife solange ausgefhrt wird, bis RegEnumKeyEx _
               nicht mehr 0 zurckliefert. Dies ist der Fall, wenn keine weitere _
               SubSection mehr gefunden wurde (Ret = ERROR_NO_MORE_ITEMS) _
               oder wenn ein Fehler aufgetreten ist.
        Do While Ret = 0
            BufLen = MaxBufLen + 1
            'BufLen = 512
            strBuffer = String$(BufLen, 0)
            Ret = RegEnumKeyEx(hOpened, Index, strBuffer, BufLen, 0&, vbNullString, 0&, FT)
            If Ret = 0 Then
                Index = Index + 1
                SColl.Add Left$(strBuffer, BufLen)
            End If
        Loop
    End If
    
    ' Zugriffsnummer hOpened wieder schliessen
    If hOpened Then
        RegCloseKey hOpened
    End If
    
    If (Ret = 0) Or (Ret = ERROR_NO_MORE_ITEMS) Then
        ' Auflistung ist fehlerfrei gelaufen, _
          SColl enthlt 0 ... x Eintrge die als Rckgabewert _
          bergeben werden
        Set GetSubSectionNames = SColl
    Else
        ' Fehlerfall ...
        mvarRegError.Number = Ret
        mvarRegError.Description = GetErrorDescription(Ret)
        mvarRegError.Source = mClassName & ".GetSubSectionNames"
        'Set GetSubSectionNames = Nothing
    End If
    ' SColl wieder zerstren
    Set SColl = Nothing
End Function


Public Function GetAllSettings(hKey As HKeyEnum, Section As String) As Collection
    ' Gibt eine Auflistung aller Eintrge eines mit hkey/Section _
      bergebenen Ordners zurck. Die zurckgegebene _
      Collection enthlt Objekte vom Typ clsGSRegSetting.
      
    ' Rckgabewert:     eine Collection mit 0 ... x clsGSRegSetting-Objekten
    '                               Nothing bei Fehler
    
    ' Aufruf:
    ' Dim i as Integer
    ' Dim RC as clsGSRegistry
    ' Dim MyCol as Collection
    ' Set RC = new clsGSRegistry
    ' Set MyCol = RC.GetAllSettings (CurrentConfig,"Software\Fonts")
    '
    ' nach erfolgreicher Ausfhrung enthlt MyCol eine Auflistung
    ' von clsGSRegSetting-Objekten, welche die Daten aller unter
    ' hKey/Section gespeicherten Eintrge (Settings) enthalten.
      
    Const N As Long = 0
    Dim SColl As Collection
    Dim I As Long
    Dim Ret As Long
    Dim hOpened As Long
    Dim Index As Long
    Dim RegDataType As Long
    Dim bArray() As Byte
    Dim NumBytes As Long
    Dim SettingName As String
    Dim SettingNameLen As Long
    Dim MaxSettingNameLen As Long
    Dim MaxSettingLen As Long
    Dim lngBuffer As Long
    Dim strBuffer As String
    
    Dim FT As FILETIME
    Dim RegS As clsGSRegSetting
    
    
    ' mvarRegError rcksetzen
    mvarRegError.Clear
    
    Set SColl = New Collection
    Ret = RegOpenKeyEx(hKey, Section, N, KEY_QUERY_VALUE, hOpened)
    ' Ret ist hier 0, wenn RegOpenKeyEx fehlerfrei gelaufen ist
    If Ret = 0 Then
        ' wie lang ist der lngste SettingName ? (MaxSettingNameLen _
          wie lang ist der lngste Setting-Inhalt ? (MaxSettingLen)
        Ret = RegQueryInfoKey(hOpened, vbNullString, N, N, N, N, N, N, MaxSettingNameLen, MaxSettingLen, N, FT)
        ' Ret ist hier 0, wenn RegQueryInfoKey fehlerfrei gelaufen ist
        
        If Ret = 0 Then
            If MaxSettingLen > 0 Then
                ' der von RegQueryInfoKey zurckgegebene Wert fr MaxSettingNameLen _
                  enthlt nicht das abschliessende vbNullChar, deshalb +1
                MaxSettingNameLen = MaxSettingNameLen + 1
            
                Do
                    ' NumBytes wird mit dem Wert von MaxSettingLen an RegEnumValue bergeben, _
                      RegEnumValue gibt nach Ausfhrung in NumBytes die tatschliche Anzahl Bytes _
                      zurck, die nach bArray() kopiert wurden
                    NumBytes = MaxSettingLen
                    
                    SettingNameLen = MaxSettingNameLen
                    SettingName = String$(MaxSettingNameLen, 0)
                    ReDim bArray(MaxSettingLen - 1)
                    
                    
                    ' beim Eintritt in die Schleife ist der Wert fr index = 0. _
                      Die Schleife wird solange wiederholt, bis RegEnumValue _
                      den Wert ERROR_NO_MORE_ITEMS zurckgibt. _
                      Am Ende jedes Schleifendurchlaufs wird der Wert fr Index um 1 erhht
                      
                    Ret = RegEnumValue(hOpened, _
                                                         Index, SettingName, _
                                                         SettingNameLen, _
                                                         N, _
                                                         RegDataType, _
                                                         bArray(0), _
                                                         NumBytes)
                                                         
                    ' Ret ist hier 0, wenn RegEnumValue fehlerfrei gelaufen ist
                    ' Ret ist hier ERROR_NO_MORE_ITEMS, _
                                        wenn kein weiterer Eintrag mehr gefunden wurde
                    
                    If Ret = 0 Then
                        ' neues clsGSRegSetting-Objekt erstellen
                        Set RegS = New clsGSRegSetting
                        
                        RegS.SettingName = Left$(SettingName, SettingNameLen)
                        ' RegS.RegDataType = RegDataType
                        
                        Select Case RegDataType
                            Case REG_SZ, REG_EXPAND_SZ, REG_MULTI_SZ
                                strBuffer = String$(NumBytes, 0)
                                Ret = RegQueryValueExString(hOpened, _
                                                                                   SettingName, _
                                                                                   N, _
                                                                                   RegDataType, _
                                                                                   strBuffer, _
                                                                                   NumBytes)
                                If Ret = 0 Then
                                    If RegDataType <> REG_MULTI_SZ Then
                                        ' Rckgabe als String
                                        RegS.Setting = Left$(strBuffer, NumBytes - 1)
                                    Else
                                        ' Rckgabe als StringArray
                                        For I = Len(strBuffer) To 1 Step -1
                                            If Asc(Mid$(strBuffer, I, 1)) <> 0 Then
                                                strBuffer = Left$(strBuffer, I)
                                                Exit For
                                            End If
                                        Next I
                                        RegS.Setting = Split(strBuffer, Chr$(0))
                                    End If
                                End If
                                
                            Case REG_DWORD
                                Ret = RegQueryValueExLong(hOpened, _
                                                                                  SettingName, _
                                                                                  N, _
                                                                                  RegDataType, _
                                                                                  lngBuffer, _
                                                                                  4)
                                If Ret = 0 Then
                                    ' Rckgabe als Long
                                    RegS.Setting = lngBuffer
                                End If
                                
                            Case Else
                                ReDim bArray(NumBytes - 1)
                                Ret = RegQueryValueExByte(hOpened, _
                                                                                 SettingName, _
                                                                                 N, _
                                                                                 RegDataType, _
                                                                                 bArray(0), _
                                                                                 NumBytes)
                                If Ret = 0 Then
                                    ' Rckgabe als ByteArray
                                    RegS.Setting = bArray
                                End If
                        End Select
                        
                        Index = Index + 1
                        SColl.Add RegS
                        Set RegS = Nothing
                    End If
                    
                    ' Schleife verlassen, wenn Ret <> 0 ist. _
                      Dies kann sein, weil RegEnumValue den Wert ERROR_NO_MORE_ITEMS zurckgegeben hat, _
                      oder weil einer der RegQueryValueEX...-Aufrufe einen Fehlerwert zurckgegeben hat.
                Loop While Ret = N
            End If
            
        End If
    End If
    
    If (Ret = N) Or (Ret = ERROR_NO_MORE_ITEMS) Then
        ' Normalfall, kein Fehler aufgetreten
        Set GetAllSettings = SColl
    Else
        ' Fehlerfall
        mvarRegError.Number = Ret
        mvarRegError.Description = GetErrorDescription(Ret)
        mvarRegError.Source = mClassName & ".GetAllSettings"
        ' Rckgabewert = Nothing
        Set GetAllSettings = Nothing
    End If
    
    ' aufrumen ...
    If hOpened Then
        RegCloseKey hOpened
    End If
    Set SColl = Nothing
End Function


Public Function CreateSection(hKey As HKeyEnum, Section As String) As Long
    ' Erzeugt einen neuen Pfad (Section) in der Registry, _
      wenn dieser noch nicht vorhanden ist.
    ' Wenn der Pfad (Section) bereits vorhanden ist, _
      wird er geffnet und wieder geschlossen
    
    ' Rckgabewert: 0 bei Fehler
    '                           1 ein neuer Pfad (Section) wurde angelegt
    '                           2 Pfad (Section) bereits vorhanden, _
                                   wurde nur geffnet u. wieder geschlossen.
    
    ' Fehlerinformationen werden in mvarRegError hinterlegt
    
    Dim hSection As Long 'Handle fr neue Section
    Dim Ret As Long
    Dim Disposition As Long
    ' Disposition = 1: ein neuer Pfad (Section) wurde erzeugt
    ' Disposition = 2: Pfad (Section) bereits vorhanden, wurde nur geffnet
    
    mvarRegError.Clear

    Ret = RegCreateKeyEx(hKey, Section, 0&, vbNullString, _
                                            REG_OPTION_NON_VOLATILE, _
                                            KEY_CREATE_SUB_KEY, _
                                            0&, hSection, Disposition)
    If Ret = 0 Then
        ' wenn RegCreateKeyEx erfolgreich gelaufen ist, _
          hSection wieder schliessen.
        RegCloseKey (hSection)
        CreateSection = Disposition
    Else
        mvarRegError.Number = Ret
        mvarRegError.Description = GetErrorDescription(Ret)
        mvarRegError.Source = "clsGSRegistry.CreateSection"
        CreateSection = 0
    End If
End Function

Public Function DeleteSection(hKey As HKeyEnum, Section As String) As Boolean
    ' Win 95: Lscht den mit hkey, Section angegebenen Ordner _
      einschl. der untergeordneten Verzeichnisse
    ' NT: Lscht den in Section angegebenen Bereich (Section), _
      wenn dieser nicht weitere Unterverzeichnisse enthlt.
    
    ' Rckgabewert: True, wenn erfolgreich gelscht wurde
    '                           False, wenn nicht gelscht werden konnte _
                                           Fehlerursache in mvarRegError

    mvarRegError.Clear
    
    Dim Ret As Long
    ' Rckgabewert fr RegDeleteKey()
    ' 0, wenn gelscht wurde
    ' Fehlernummer <> 0, wenn nicht gelscht werden konnte
    
    Ret = RegDeleteKey(hKey, Section)
    
    If Ret = 0 Then
        DeleteSection = True
    Else
        mvarRegError.Number = Ret
        mvarRegError.Description = GetErrorDescription(Ret)
        mvarRegError.Source = "clsGSRegistry.DeleteSection"
    End If
End Function


Public Function ReadSetting(hKey As HKeyEnum, Section As String, SettingName As String) As clsGSRegSetting
    ' Gibt ein clsGSRegSetting-Objekt mit den Eigenschaften _
      "SettingName", "RegDataType" und "Setting" zurck
      
    ' Im Fehlerfall ist der Rckgabewert = Nothing _
      Informationen zum Fehler in mvarRegError
    
    Dim I As Long
    Dim Ret As Long
    Dim hKeyOpened As Long
    Dim DataLen As Long
    Dim lngBuffer As Long
    Dim strBuffer As String
    
    Dim DataType As RegDataTypes
    Dim bArray() As Byte
    Dim RK As clsGSRegSetting
    
    mvarRegError.Clear
    
    Set RK = New clsGSRegSetting
    
    Ret = RegOpenKeyEx(hKey, Section, 0, KEY_QUERY_VALUE, hKeyOpened)
    ' Ret ist hier 0, wenn die mit hKey/Section bergebene _
      Section fehlerfrei geffnet werden konnte
    If Ret = 0 Then
        ' Lnge und Datentyp des Eintrags ermitteln, _
          lpData wird mit 0& bergeben, DataLen liefert dann die _
          fr bArray() notwendige Grsse
        Ret = RegQueryValueExNULL(hKeyOpened, SettingName, 0&, DataType, 0&, DataLen)
        ' Ret ist hier 0, wenn RegQueryValueExNull fehlerfrei gelaufen ist.
        If Ret = 0 Then
            Set RK = New clsGSRegSetting
            
            RK.SettingName = SettingName
            
            Select Case DataType
                Case REG_SZ, REG_EXPAND_SZ, REG_MULTI_SZ
                    strBuffer = String$(DataLen, 0)
                    Ret = RegQueryValueExString(hKeyOpened, SettingName, 0&, DataType, strBuffer, DataLen)
                    If Ret = 0 Then
                        If DataType <> REG_MULTI_SZ Then
                            ' Rckgabe als String
                            If Len(strBuffer) > 0 Then
                                RK.Setting = Left$(strBuffer, DataLen - 1)
                            Else
                                RK.Setting = ""
                            End If
                        Else
                            ' Rckgabe als StringArray
                            For I = Len(strBuffer) To 1 Step -1
                                If Asc(Mid$(strBuffer, I, 1)) <> 0 Then
                                    strBuffer = Left$(strBuffer, I)
                                    Exit For
                                End If
                            Next I
                            RK.Setting = Split(strBuffer, Chr$(0))
                        End If
                    End If
                    
                Case REG_DWORD
                    Ret = RegQueryValueExLong(hKeyOpened, SettingName, 0&, DataType, lngBuffer, 4)
                    If Ret = 0 Then
                        ' Rckgabe als Long
                        RK.Setting = lngBuffer
                    End If
                    
                Case Else
                    ReDim bArray(DataLen - 1)
                    Ret = RegQueryValueExByte(hKeyOpened, SettingName, 0&, DataType, bArray(0), DataLen)
                    If Ret = 0 Then
                        ' Rckgabe als ByteArray
                        RK.Setting = bArray
                    End If
            End Select
        End If
    End If
    
    If Ret = 0 Then
'        ' Alles fehlerfrei gelaufen
'        ' RegS.Setting muss vorher versorgt worden sein, _
'          damit Regs.TypeNameVB und RegS.VarTypeVB _
'          die richtigen Werte erhalten. (s. clsGSRegSetting Property Let RegDataType)
'        RK.RegDataType = DataType
        Set ReadSetting = RK
    Else
        ' Es ist ein Fehler aufgetreten
        mvarRegError.Number = Ret
        mvarRegError.Description = GetErrorDescription(Ret)
        mvarRegError.Source = mClassName & ".ReadSetting"
    End If
End Function

Public Function WriteSetting(hKey As HKeyEnum, _
                                               Section As String, _
                                               SettingName As String, _
                                               Setting As Variant) As Long
                                               
    ' Schreibt einen neuen Eintrag (Setting) in den mit hKey/Section angegebenen Pfad.
    ' Ist der Pfad (Section) noch nicht vorhanden, so wird er erzeugt.
    
    ' hKey:             ein Wert aus der HKeyEnum-Aufzhlung
    ' Section:         Pfadangabe (Section) fr den Eintrag (z.B: "SYSTEM\Setup")
    ' SettingName:     der Name des Eintrages
    ' Setting:          der Wert (Value) des Eintrages
                                               
    ' Rckgabewerte:       0   Fehler
    '                                   1   ein neuer Pfad (Section) wurde erzeugt
    '                                   2   Pfad (Section) war bereits vorhanden, wurde nur geffnet
    
                                     
    ' Folgende DatenTypen knnen in Setting bergeben werden:
    '
    '                   ByteArray                (wird als REG_BINARY gespeichert)
    '                   StringArray              (wird als REG_MULTI_SZ gespeichert)
    '                   Byte, Integer, Long  (wird als REG_DWORD gespeichert)
    '                   String                       (wird als REG_SZ oder REG_EXPAND_SZ gespeichert)
    
    ' andere Datentypen werden nicht gespeichert, _
      mvarRegError gibt in diesem Fall den Fehler 13 (unzulssiger Datentyp) zurck
    
    Dim I As Long
    Dim Ret As Long
    Dim hKeyOpened
    Dim Disposition As Long
    Dim strBuffer As String
    Dim lngBuffer As Long
    Dim bArray() As Byte
    Dim DType As RegDataTypes
    
    ' RegError rcksetzen
    mvarRegError.Clear
    
    On Error GoTo Fehler:
    
    ' Datentyp (DataType) der in Setting bergebenen Daten ermitteln _
      und an die jeweils passende Variable (bArray(), lngBuffer, strBuffer) bergeben.
    If VarType(Setting) And vbArray Then
        ' es wurde ein Array bergeben _
          (es sind nur String- oder ByteArrays zulssig)
        Select Case True
            Case VarType(Setting) And vbByte
                ' ByteArray
                DType = BinaryData
                bArray = Setting
                
            Case VarType(Setting) And vbString
                ' StringArray
                DType = MultipleText
                For I = LBound(Setting) To UBound(Setting)
                    strBuffer = strBuffer & Setting(I) & Chr$(0)
                Next I
                strBuffer = strBuffer & Chr$(0)
                
            Case Else
                ' andere Datentypen in Arrays sind nicht zulssig
                I = ""      ' Lst den Fehler 13 (unzulssiger Datentyp aus)
        End Select
    Else
        Select Case VarType(Setting)
            Case vbByte, vbInteger, vbLong
                ' Ganzzahl-Werte Byte, Integer, Long werden _
                  als Datentyp DWord gespeichert
                DType = Numeric_Long
                lngBuffer = Setting
                
            Case vbString
                strBuffer = Setting
                ' prfen, ob strBuffer einen String mit nicht aufgelsten _
                  Referenzen auf EnvironVariablen enthlt
                If IsUnexpEnviron(strBuffer) Then
                    DType = TextUnexpEnviron
                Else
                    DType = Text
                End If
                
            Case Else
                ' andere DatenType sind nicht zulssig
                I = ""      ' Lst den Fehler 13 (unzulssiger Datentyp aus)
        End Select
    End If
        
    ' Den in Section bergebenen Pfad ffnen. _
      RegCreateKeyEx ffnet den Pfad, sofern er bereits vorhanden ist, _
      ist er noch nicht vorhanden, wird er neu angelegt.
    ' Disposition zeigt an, ob der Pfad bereits vorhanden war
    ' Disposition = 1: ein neuer Key wurde erzeugt
    ' Disposition = 2: Key bereits vorhanden, wurde nur geffnet
    Ret = RegCreateKeyEx(hKey, _
                                         Section, _
                                         0&, _
                                         vbNullString, _
                                         REG_OPTION_NON_VOLATILE, _
                                         KEY_CREATE_SUB_KEY Or KEY_SET_VALUE, _
                                         0&, _
                                         hKeyOpened, _
                                         Disposition)
                                         
    ' Ret ist hier 0, wenn RegCreateKeyEx fehlerfrei gelaufen ist
    If Ret = 0 Then
        ' abhngig vom DatenTyp werden jetzt die Daten gespeichert
        Select Case DType
            Case BinaryData
                Ret = RegSetValueExByte(hKeyOpened, SettingName, 0&, DType, bArray(0), (UBound(bArray) - LBound(bArray)) + 1)
            Case Numeric_Long
                Ret = RegSetValueExLong(hKeyOpened, SettingName, 0&, DType, lngBuffer, Len(lngBuffer))
            Case Text, TextUnexpEnviron, MultipleText
                Ret = RegSetValueExString(hKeyOpened, SettingName, 0&, DType, strBuffer, Len(strBuffer))
            Case Else
                ' sollte normalerweise nicht vorkommen, da die Datentypen _
                  bereits oben selectiert wurden.
                I = ""          ' lst Fehler 13 aus
        End Select
    End If
    
    If Ret <> 0 Then
        Disposition = 0
        mvarRegError.Number = Ret
        mvarRegError.Description = GetErrorDescription(Ret)
        mvarRegError.Source = mClassName & ".WriteSetting"
    End If
    
Ausgang:
    WriteSetting = Disposition
    On Error GoTo 0
    
Exit Function

Fehler:
    mvarRegError.Number = Err.Number
    mvarRegError.Description = Err.Description
    mvarRegError.HelpContext = Err.HelpContext
    mvarRegError.LastDllError = Err.LastDllError
    mvarRegError.HelpFile = Err.HelpFile
    mvarRegError.Source = mClassName & ".WriteSetting"
    Disposition = 0
    Resume Ausgang
End Function

Public Function DeleteSetting(hKey As HKeyEnum, Section As String, SettingName As String) As Boolean
    ' Lscht den unter HKEY - Section\SettingName gespeicherten Wert

    ' Rckgabewert:
    ' True, wenn Lschen erfolgreich war
    ' False bei Fehler (Fehlerinfo in mvarRegError)

    Dim Ret As Long 'Rckgabewert der API-Funktionen
    Dim hKeyOpened As Long 'Handle des akt. geffneten Keys

    mvarRegError.Clear
    
    Ret = RegOpenKeyEx(hKey, Section, 0, KEY_SET_VALUE, hKeyOpened)
    If Ret = 0 Then
        ' Setting Lschen
        Ret = RegDeleteValue(hKeyOpened, SettingName)
        
        ' Zugriffsnummer hKeyOpened wieder schliessen
        RegCloseKey hKeyOpened
    End If
    
    If Ret = 0 Then
        DeleteSetting = True
    Else
        mvarRegError.Number = Ret
        mvarRegError.Description = GetErrorDescription(Ret)
        mvarRegError.Source = "clsGSRegistry.DeleteSetting"
    End If
End Function



Private Sub Class_Initialize()
    ' Instanz des ErrorObjekts erstellen
    Set mvarRegError = New clsGSError
End Sub

Private Sub Class_Terminate()
    ' ErrorObjekt zerstren
    Set mvarRegError = Nothing
End Sub
